Description

| have written a work-in-progress GitHub registration script. | published the fix on GitHub because | can :>
https://github.com/JacobKfromIRC/Site-Fixes-for-GitHub

Currently the fix is a bit complicated to use, and it is not very well tested. | plan to improve it to make it easier to use, but | wanted to
let people know about it now since it does function, and you only need to create an account once.

History

#1 - 08/30/2022 09:14 AM - koszko

Thanks, this has a potential to be very useful :)
Upon registering, have you noticed anything bad in GitHub's ToS that we should be aware of?

Btw, in cases where one mapping expects another to be installed (e.g. to make an iframe on some page functional), you can use the new
"required_mappings" key in index.json to indicate that. This feature is available starting from Hydrilla 1.1 and Haketilo 2.0. It's my fault that | didn't
document it on the wiki... Anyway, you can see (and | suppose you've already seen) an example here :)

#2 - 08/30/2022 08:24 PM - jacobk

Strangely | don't remember GitHub asking me to agree to a terms of service. | did find a terms page [1], but there's a lot of pages, so | haven't read
them all yet. The only thing I've noticed so far is that the GitHub Terms of Service [2] says "One person or legal entity may maintain no more than one
free Account", which | definitely violated in testing (and, I've made multiple accounts for school before too, before | knew about free software). But of
course that's not a problem inherent to the free software client, just something that's a bit more likely to occur when developing a client (Though, now
that | know the launch code entry page doesn't require JavaScript, | can just test getting to that page, as getting to that page doesn't require actually
accessing the email used.). I'll make another comment if | find something else more concerning in the terms.

[1] https://docs.qithub.com/en/site-policy/github-terms

[2] https://docs.github.com/en/site-policy/github-terms/github-terms-of-service

#3 - 08/30/2022 08:27 PM - jacobk

Oh also, thanks for the required_mappings example. For some reason | didn't think to look at Hacktcha for an example... For some reason | thought |
would need multiple resources but then one mapping that links all of them, but | guess required_mappings is better because that means you can still
install individual lower level components by themselves if you want (e.g. just the Octocaptcha).

#4 - 09/01/2022 09:03 AM - koszko
https://github.com/JacobKfromIRC/Site-Fixes-for-GitHub
https://git.koszko.org/haketilo-packages/hacktcha/tree/index.json#n24
https://docs.github.com/en/site-policy/github-terms
https://docs.github.com/en/site-policy/github-terms/github-terms-of-service

jacobk wrote:

Oh also, thanks for the required_mappings example.

YW )

Whether multiple payloads would actually suffice in this case - | don't know for sure. | can't find any evidence of Octocaptcha being used somewhere
else... but you also have some code to integrate with funcaptcha. And this one seems to also be used by other websites, is that correct?

#5 - 09/02/2022 10:32 PM - jacobk

| doubt there are other sites using Octocaptcha, as | think the name refers to the GitHub mascot, but it is possible to solve the Octocaptcha by itself
for testing [1], and the URL has query strings with makes me think maybe some other parts of the site use Octocaptcha differently?

| think Octocaptcha is basically GitHub's custom frontend for FunCaptcha, so | think other sites do use FunCaptcha. If | remember correctly, Roblox
uses FunCaptcha, but | think it's a different kind of FunCaptcha so I'm not sure if the code | have already written would carry over.

Also, for some reason | was unable to get Hydrilla to serve the GitHub scripts without upgrading to from Hydrilla 1.0 to Hydrilla 1.1b. Other packages
seemed to work fine on 1.0.

[1] https://octocaptcha.com/?origin_page=github_signup_next&responsive=true&require_ack=true&version=2

#6 - 09/03/2022 11:49 AM - koszko

Also, for some reason | was unable to get Hydrilla to serve the GitHub scripts without upgrading to from Hydrilla 1.0 to Hydrilla 1.1b.

The convenient "mapping_and_resource" was only added in 1.1b1. Well, it's only applicable to Hydrilla builder (the definitions it produces don't use
such shortcuts), so serving stuff that was already built should also be possible with 1.0. Which is probably not very useful under local development
setting since server requires exactly the same version of builder to be installed...

#7 - 09/17/2022 06:07 AM - jacobk

With the current version of the fix, using the HTTPS Everywhere extension with "Encrypt All Sites Eligible" enabled will break the visual component of
the script. | have not investigated why this happens yet. Firefox/Abrowser's built-in "HTTPS-Only Mode" does not seem to cause problems.

#8 - 09/17/2022 06:39 AM - jacobk
https://octocaptcha.com/?origin_page=github_signup_next&responsive=true&require_ack=true&version=2

Also, I've been occasionally running into a problem when updating fixes, in which Haketilo for some reason keeps requesting an old resource after
downloading a new mapping, and removing the resource leads to getting a 404 when trying to install the fix (as the old resource is no longer in the
build directory). Removing the mapping in Haketilo too does not seem to fix it, but neither does deleting and restoring the build directory, so | think the
problem is with Haketilo.

| haven't seen this happen on my profile that only has Haketilo installed, so | can't say for sure that it's not the interference of another extension that's
causing the problem, but it would be weird if it was another extension's fault since the requests are happening in the context of the extension and not
a web page. If | catch it happening on Haketilo by itself, then I'll open a separate issue for it.

#9 - 09/17/2022 09:13 PM - koszko

jacobk wrote:

so | think the problem is with Haketilo.

No, it's a problem with Hydrilla [

Browser caches some of the responses. It does not cache the ones that are generated dynamically with Python code but it can cache files served
with flask's send_file() function. This line needs to be changed.

| experienced that bug before but didn't actually prioritize fixing it since the issue only manifests itself when running a development server of Hydrilla.
So far I've been just using Ctrl+Shift+del Firefox shortcut to quickly clear the browser's cache

No need for you to create a new issue for it - I'll correct this behavior in the next release!

#10 - 10/08/2022 04:24 AM - jacobk

The fix as it is now is maybe good enough to publish. It's now usable entirely through the GUI, but audio CAPTCHA is still the only option, and there
are some values sent in requests that | am not sure how to get/generate, namely "bda" and "bio", which apparently aren't actually necessary, but
sending "???" for them makes it very easy for GitHub to tell that people are using the script, if they decide they want to block it for some reason, or if
they decide that most user of the script were actually bots, and they want to ban all users that used the script (not sure if they'd really do that though).

Both "bda" and "bio" are very long strings of variable length that start with "ey", and I've seen strings that match that description outside of GitHub
(e.g. on Microsoft login if | remember correctly, though in that case | was able to tell where the value came from IIRC), and | did find a website that
might be talking about something similar to what GitHub does, but I'm not sure:

https://aws.amazon.com/premiumsupport/knowledge-center/appsync-wrong-query-item-number-dynamodb/

#11 - 10/08/2022 04:26 AM - jacobk

Oops, the duplicate comments are because of Abrowser showing an HTTPS-Only Mode warning when | try to submit, but then when | go back the
message is still in the edit box so | think it wasn't sent, but it actually was sent despite the error message.
https://git.koszko.org/pydrilla/tree/src/hydrilla/server/serve.py?h=v1.1-beta1#n553
https://aws.amazon.com/premiumsupport/knowledge-center/appsync-wrong-query-item-number-dynamodb/

Not sure if that's an Abrowser/Firefox issue or a Hydrilla-issue-tracker/Redmine issue.
#12 - 10/08/2022 07:22 AM - koszko
jacobk wrote:

The fix as it is now is maybe good enough to publish.

Thanks! I'll look at it soon.

there are some values sent in requests that | am not sure how to get/generate

| had a similar problem with reCAPTCHA (although the strings there used a different format) and after some thinking | decided not to worry about it
too much. Especially considering how much precious time RE-ing the generation of those strings could take.

Oops, the duplicate comments are because of Abrowser showing an HTTPS-Only Mode warning when | try to submit [...]

No problem, | removed the duplicates :)

Not sure if that's an Abrowser/Firefox issue or a Hydrilla-issue-tracker/Redmine issue.

It could be a hydrillabugs issue as at some point, after renaming "Hachette" to "Haketilo", | used Apache's mod_html to replace all "hachette" links in
pages being served with "haketilo" links... | later realized this was a mistake as one of the side-effects was the rendering of hydrillabugs in Quirks
mode. Perhaps this also caused the HTTP-only mode issue?

| changed the Apache configuration to not perform any HTML rewrites (I should've done that long ago...). Let's see if the issues persist now.

#13 - 10/29/2022 08:23 AM - jacobk
| found some information about "bda" that looks like it would be very useful if GitHub decides to start checking for it. It looks like it is for fingerprinting.

https://github.com/keepitL owkey/py-funcaptcha/blob/master/py_funcaptcha.py

#14 - 10/29/2022 08:28 AM - jacobk

Also this looks like it has some information about solving visual CAPTCHAS, but | haven't looked into it much: https://archive.ph/GbaCZ

#15 - 10/29/2022 11:16 AM - koszko

Disgusting. Well, good to know at least.

Would be cool to at some point spend more time RE-ing this kind of stuff (it's actually more entertaining than work on Haketilo itself)
https://github.com/keepitLowkey/py-funcaptcha/blob/master/py_funcaptcha.py
https://archive.ph/GbaCZ
